<template>
    <div class="lastPage-createNewUser animated fadeInUp">
        <div class="topAllUser">
            <p class="text-bold">{{ $t('users.create_form.title') }}</p>
            <p class="text-allUser">{{ $t('users.create_form.total') }} <span>{{ total }}</span></p>
        </div>
        <form action="" @submit.prevent="create">
            <div class="box__leftInput">
                <div class="box-input">
                    <label for="loginField">{{ $t('users.create_form.login') }}</label>
                    <input type="text" id="loginField" v-model="form.login">
                </div>
                <div class="box-input">
                    <label for="passwordField">{{ $t('users.create_form.password') }}</label>
                    <input type="password" id="passwordField" v-model="form.password">
                </div>
                <div class="box-input">
                    <label for="emailField">{{ $t('users.create_form.email') }}</label>
                    <input type="email" id="emailField" v-model="form.email">
                </div>
                <div class="box-input">
                    <label for="confirmPasswordField">{{ $t('users.create_form.password_repeat') }}</label>
                    <input type="password" id="confirmPasswordField" v-model="form.password_confirmation">
                </div>
            </div>
            <button class="save_noBg" type="submit">{{ $t('users.create_form.submit') }}</button>
        </form>
    </div>
</template>

<script>
	import {mapGetters} from "vuex";
	import laravelValidationErrorParse from "../../mixins/laravelValidationErrorParse";

    export default {
		name: "Create",
        mixins: [laravelValidationErrorParse],
        data(){
            return {
                total: 0,
                form: {
                    login: '',
                    password: '',
                    password_confirmation: '',
                    email: ''
                }
            }
        },
        computed: {
            ...mapGetters([
                'axios',
                'csrf'
            ])
        },
        methods: {
            loadTotal(){
                this.axios
                    .get('users/count')
                    .then(resp => resp.data)
                    .then(data => {
                        this.total = Number.parseInt(data.total) || 0;
                    })
            },
            create(){
                let form_data = Object.assign({
                    _token: this.csrf
                }, this.form);

                this.axios.post('users', form_data)
                    .then(resp => resp.data)
                    .then(data => {
                        if('success' === data.status){
                            this.$swal(this.$t('ui.success'));
                            this.$emit('created');
                        }else{
                            this.$swal(this.$t('ui.error'), data.message, 'error')
                        }
                    })
                    .catch((error) => {
                        this.displayErrorsSwal(error);
                    });
            }
        },
        mounted(){
            this.loadTotal();
        },
	}
</script>

<style scoped>

</style>
